Bug 1305496 - Review Request: HdrHistogram - A High Dynamic Range Histogram
Summary: Review Request: HdrHistogram - A High Dynamic Range Histogram
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: jiri vanek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: bigdata-review
TreeView+ depends on / blocked
 
Reported: 2016-02-08 12:35 UTC by Tomas Repik
Modified: 2016-04-22 12:15 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2016-03-17 20:51:51 UTC
jvanek: fedora-review+


Attachments (Terms of Use)

Description Tomas Repik 2016-02-08 12:35:09 UTC
Spec URL: https://trepik.fedorapeople.org/HdrHistogram.spec
SRPM URL: https://trepik.fedorapeople.org/HdrHistogram-2.1.8-1.fc23.src.rpm

Description: HdrHistogram supports the recording and analyzing sampled data value counts across a configurable integer value range with configurable value
precision within the range. Value precision is expressed as the number of
significant digits in the value recording, and provides control over value
quantization behavior across the value range and the subsequent value
resolution at any given level.

Fedora Account System Username: trepik

Comment 1 jiri vanek 2016-02-26 11:50:58 UTC
But I cant be sponsor. (iirc)

Comment 2 jiri vanek 2016-02-27 16:21:14 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated". 93 files have unknown
     license. Detailed output of licensecheck in
     /home/jvanek/1305496-HdrHistogram/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     HdrHistogram-javadoc
[!]: Package functions as described.
[-]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: HdrHistogram-2.1.8-1.fc23.noarch.rpm
          HdrHistogram-javadoc-2.1.8-1.fc23.noarch.rpm
          HdrHistogram-2.1.8-1.fc23.src.rpm
HdrHistogram.noarch: W: spelling-error %description -l en_US quantization -> quantification, equalization, tantalization
HdrHistogram.src: W: spelling-error %description -l en_US quantization -> quantification, equalization, tantalization
3 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
HdrHistogram (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils

HdrHistogram-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
HdrHistogram:
    HdrHistogram
    mvn(org.hdrhistogram:HdrHistogram)
    mvn(org.hdrhistogram:HdrHistogram:pom:)
    osgi(org.hdrhistogram.HdrHistogram)

HdrHistogram-javadoc:
    HdrHistogram-javadoc



Source checksums
----------------
https://github.com/HdrHistogram/HdrHistogram/archive/HdrHistogram-2.1.8.tar.gz :
  CHECKSUM(SHA256) this package     : 72c4cf1be8c0002d69a216e68a685603f0fdd6fdd1f5f68896456682381c323d
  CHECKSUM(SHA256) upstream package : 72c4cf1be8c0002d69a216e68a685603f0fdd6fdd1f5f68896456682381c323d


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1305496
Buildroot used: fedora-23-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 jiri vanek 2016-02-27 16:27:16 UTC
[!]: %check is present and all tests pass.

Unless there is some reason I cant see, i probably insists execution of tests during build. there is even  junit in In original sources.


[!]: Package functions as described.

There is quite a lot interesting things in the source tarball. One of them is launcher. Others are web based histrograms. I would expect them to work in installed application. Rightnow they are just missing.

Comment 4 Tomas Repik 2016-02-29 11:18:20 UTC
(In reply to jiri vanek from comment #3)
> [!]: %check is present and all tests pass.
> 
> Unless there is some reason I cant see, i probably insists execution of
> tests during build. there is even  junit in In original sources.

Tests are executed during build, using maven-surefire-plugin. Only HistogramPerfTest is not run, but I don't think it's necessary. As [1] tells: "Optional %check section
Runs projects integration tests. Unit test are usually run in %build section, so if there are no integration tests available, this section is omitted"
 
> [!]: Package functions as described.
> 
> There is quite a lot interesting things in the source tarball. One of them
> is launcher. Others are web based histrograms. I would expect them to work
> in installed application. Rightnow they are just missing.

I can't see any more files needed to be installed. Can you be more specific?

[1] https://fedorahosted.org/released/javapackages/doc/#_example_rpm_project

Comment 5 jiri vanek 2016-02-29 13:13:18 UTC
(In reply to Tomas Repik from comment #4)
> (In reply to jiri vanek from comment #3)
> > [!]: %check is present and all tests pass.
> > 
> > Unless there is some reason I cant see, i probably insists execution of
> > tests during build. there is even  junit in In original sources.
> 
> Tests are executed during build, using maven-surefire-plugin. Only
> HistogramPerfTest is not run, but I don't think it's necessary. As [1]
> tells: "Optional %check section
> Runs projects integration tests. Unit test are usually run in %build
> section, so if there are no integration tests available, this section is
> omitted"

I always forget that forcing maven run build and tests one by one is a bit hackisch.  So yes, I donto wont to foorce you to split build and test run. And integration tests seems really not necessary.
>  
> > [!]: Package functions as described.
> > 
> > There is quite a lot interesting things in the source tarball. One of them
> > is launcher. Others are web based histrograms. I would expect them to work
> > in installed application. Rightnow they are just missing.
> 
> I can't see any more files needed to be installed. Can you be more specific?
> 
> [1] https://fedorahosted.org/released/javapackages/doc/#_example_rpm_project

You are saying yoursef:  48: %jpackage_script org.fedoraproject.helloworld.HelloWorld "" "" %{name} helloworld true

:)

More serious - there is launcher HistogramLogProcessor. I watched it more closely, and although it probably deserves to be rewritten and packed inside  as launcher, it do not seems to be doing main functionality of this package.

Originally I thougth that this program will take an fil/input of numbers and create histogram..image...

But looking to list of mainclasses:
src/perf/java/org/HdrHistogram/HistogramPerfTest.java:    public static void main(String[] args) {
src/main/java/org/HdrHistogram/HistogramLogProcessor.java:    public static void main(final String[] args)  {
src/examples/java/SimpleHistogramExample.java:    public static void main(final String[] args) {


My assumption was probably wrong. Thoughts?

Comment 6 Tomas Repik 2016-02-29 17:16:47 UTC
Well, first of all thanks for the review, I appreciate it. 

> Thoughts?
For me it's more like a library than a real runable application although it would make sense as well. I could try and create something like subpackage with the main class from HistogramLogProcessor.java, but it's not the core function and not important to include.

Comment 7 jiri vanek 2016-03-01 07:34:14 UTC
I can agree on it. But Still I would say  - upstream have an launcher => include launcher.
No subpackage needed.

Comment 8 Tomas Repik 2016-03-02 13:19:34 UTC
Spec URL: https://trepik.fedorapeople.org/HdrHistogram.spec
SRPM URL: https://trepik.fedorapeople.org/HdrHistogram-2.1.8-2.fc23.src.rpm

* Wed Mar 02 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-2
- launcher HistogramLogProcessor installation

Comment 9 jiri vanek 2016-03-02 15:29:41 UTC
Hello!

You tried to install this package+launcher and it worked?

I did not, but:
cp HistogramLogProcessor %{buildroot}%{_libdir}/HistogramLogProcessor 

Can never work.
Even ig, it is against all guidelines.
Check: https://fedorahosted.org/released/javapackages/doc/#_example_rpm_project :
48: %jpackage_script org.fedoraproject.helloworld.HelloWorld "" "" %{name} helloworld true

Also I would go with %{_bindir}  : 
https://fedoraproject.org/wiki/Packaging:RPMMacros?rd=Packaging/RPMMacros

Unlkess tehre is something really mysterious, you have to rewrite the launcher.
For the launcher - googling is not much useful, but the doc above should be enough. If you will wail, I will help you bit more...

Comment 10 Tomas Repik 2016-03-03 11:34:33 UTC
(In reply to jiri vanek from comment #9)
> 48: %jpackage_script org.fedoraproject.helloworld.HelloWorld "" "" %{name}
> helloworld true
Done.
> Also I would go with %{_bindir}
Done.

Also installed and tried running (with no error)
$ HistogramLogProcessor -h

I would also try other functionality but, I can't find a propper log file to test it on.

Comment 11 jiri vanek 2016-03-04 12:50:05 UTC
Thanx!
It looks good.
Just for curiosity - heve you seen your generated /usr/bin/HistogramLogProcessor ?-)

From my side the package is ok.
Before initial push I would recommend you to reset release to 1.

One note for future - its quite good to publish the spec/srpm in versioned way. Somthing like:
Spec URL: https://trepik.fedorapeople.org/v1/HdrHistogram.spec
SRPM URL: https://trepik.fedorapeople.org/v1/HdrHistogram-2.1.8-1.fc23.src.rpm
later
Spec URL: https://trepik.fedorapeople.org/v2/HdrHistogram.spec
SRPM URL: https://trepik.fedorapeople.org/v2/HdrHistogram-2.1.8-2.fc23.src.rpm
...
Spec URL: https://trepik.fedorapeople.org/vN/HdrHistogram.spec
SRPM URL: https://trepik.fedorapeople.org/vN/HdrHistogram-2.1.8-N.fc23.src.rpm

By so, the reviwer can easily diff what you had modified in spec/srpm

And of course reset the release at the end...

Comment 12 jiri vanek 2016-03-04 12:52:38 UTC
Not sure how your other requests, but this oen was missing fedora-review=?
If your other requestsd are missing it, set it for your own good.

This package is APPROVED.

Comment 13 Tomas Repik 2016-03-07 11:51:34 UTC
(In reply to jiri vanek from comment #11)
> Thanx!
> It looks good.
> Just for curiosity - heve you seen your generated
> /usr/bin/HistogramLogProcessor ?-)
Yes I did check that file.

> From my side the package is ok.
> Before initial push I would recommend you to reset release to 1. 
Done.
> One note for future - its quite good to publish the spec/srpm in versioned
> way. Somthing like:
> Spec URL: https://trepik.fedorapeople.org/v1/HdrHistogram.spec
> SRPM URL:
> https://trepik.fedorapeople.org/v1/HdrHistogram-2.1.8-1.fc23.src.rpm
> later
> Spec URL: https://trepik.fedorapeople.org/v2/HdrHistogram.spec
> SRPM URL:
> https://trepik.fedorapeople.org/v2/HdrHistogram-2.1.8-2.fc23.src.rpm
> ...
> Spec URL: https://trepik.fedorapeople.org/vN/HdrHistogram.spec
> SRPM URL:
> https://trepik.fedorapeople.org/vN/HdrHistogram-2.1.8-N.fc23.src.rpm
> 
> By so, the reviwer can easily diff what you had modified in spec/srpm
> 
> And of course reset the release at the end...
Thank you for the review, your guidance and useful tips. I'm goona keep them in mind, for the future.

Comment 14 Tomas Repik 2016-03-07 11:55:57 UTC
(In reply to jiri vanek from comment #12)
> Not sure how your other requests, but this oen was missing fedora-review=?
> If your other requestsd are missing it, set it for your own good.
I think the reviewer should set the fedora-review flag=? based on[1]:

"Wait for someone to review your package! At this point in the process, the fedora-review flag is blank, meaning that no reviewer is assigned"

and

"A reviewer takes on the task of reviewing your package. They will set the fedora-review flag to ?"

[1] https://fedoraproject.org/wiki/Package_Review_Process

Comment 15 Tomas Repik 2016-03-07 12:13:56 UTC
Spec URL: https://trepik.fedorapeople.org/HdrHistogram/HdrHistogram.spec
SRPM URL: https://trepik.fedorapeople.org/HdrHistogram/HdrHistogram-2.1.8-1.fc23.src.rpm

* Mon Mar 07 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-1
- launcher HistogramLogProcessor installation
- Update to 2.1.8

Comment 16 jiri vanek 2016-03-07 12:36:20 UTC
Yah, you are right with flags.

About the c#15 - was there some change against the original one i approved?
If so, please post diff!

I short time I should be able to sponsor you.

Comment 17 Tomas Repik 2016-03-07 13:02:45 UTC
--- SPECS/old/HdrHistogram.spec	2016-03-03 15:58:04.925801810 +0100
+++ SPECS/HdrHistogram.spec	2016-03-07 12:37:58.916005527 +0100
@@ -1,6 +1,6 @@
 Name:          HdrHistogram
 Version:       2.1.8
-Release:       2%{?dist}
+Release:       1%{?dist}
 Summary:       A High Dynamic Range (HDR) Histogram
 License:       BSD and CC0
 URL:           http://hdrhistogram.github.io/%{name}/
@@ -59,10 +59,8 @@
 %license COPYING.txt LICENSE.txt
 
 %changelog
-* Thu Mar 03 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-2
+* Mon Mar 07 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-1
 - launcher HistogramLogProcessor installation
-
-* Mon Feb 08 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-1
 - Update to 2.1.8
 
 * Thu Oct 22 2015 gil cattaneo <puntogil@libero.it> 2.1.7-1

Comment 18 Gwyn Ciesla 2016-03-07 14:05:59 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/HdrHistogram

Comment 19 jiri vanek 2016-03-08 07:49:44 UTC
(In reply to Tomas Repik from comment #17)
> --- SPECS/old/HdrHistogram.spec	2016-03-03 15:58:04.925801810 +0100
> +++ SPECS/HdrHistogram.spec	2016-03-07 12:37:58.916005527 +0100
> @@ -1,6 +1,6 @@
>  Name:          HdrHistogram
>  Version:       2.1.8
> -Release:       2%{?dist}
> +Release:       1%{?dist}
>  Summary:       A High Dynamic Range (HDR) Histogram
>  License:       BSD and CC0
>  URL:           http://hdrhistogram.github.io/%{name}/
> @@ -59,10 +59,8 @@
>  %license COPYING.txt LICENSE.txt
>  
>  %changelog
> -* Thu Mar 03 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-2
> +* Mon Mar 07 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-1
>  - launcher HistogramLogProcessor installation
> -
> -* Mon Feb 08 2016 Tomas Repik <trepik@redhat.com> - 2.1.8-1
>  - Update to 2.1.8
>  
>  * Thu Oct 22 2015 gil cattaneo <puntogil@libero.it> 2.1.7-1

Thanx!

The change is really harmless.

Comment 20 Fedora Update System 2016-03-08 11:37:59 UTC
HdrHistogram-2.1.8-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-3cc7c1c581

Comment 21 Fedora Update System 2016-03-09 22:56:39 UTC
HdrHistogram-2.1.8-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-3cc7c1c581

Comment 22 Fedora Update System 2016-03-17 20:51:49 UTC
HdrHistogram-2.1.8-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.